<template lang="pug">
  div
    v-card
      v-card-title Projects
      v-card-text
        v-data-table(
          :headers="headers"
          :items="projects.data"
          :items-per-page="10"
          class="elevation-0"
          v-model="selected"
          show-select
          single-select
          @click:row="rowClick"
        )
        v-btn#deleteProject.float-left(
          color="warning"
        ) Delete
        v-btn#EditProject.float-right(
          @click="editSelectedProject"
          color="success"
        ) Edit
      v-fab-transition
        v-btn#newProject(
          color="success"
          bottom
          right
          large
          fixed
          fab
        )
          v-icon mdi-plus-circle-outline
    v-dialog(
      v-model="showModal"
      activator="#newProject"
      persistent
    )
      v-card
        v-card-title New Project
        v-card-text
          v-text-field(
            label="Project Name"
            v-model="newProject.name"
          )
          v-text-field(
            label="Project Code"
            v-model="newProject.code"
          )
          v-textarea(
            label="Description"
            v-model="newProject.description"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="showModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveNewProject"
            ) Save
    v-dialog(
      v-model="editModal"
      persistent
    )
      v-card
        v-card-title Edit Project
        v-card-text
          v-text-field(
            label="Project Name"
            v-model="editProject.name"
          )
          v-text-field(
            label="Project Code"
            v-model="editProject.code"
          )
          v-textarea(
            label="Description"
            v-model="editProject.description"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="editModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveEditProject"
            ) Save
    v-dialog(
      v-model="areYouSure"
      activator="#deleteProject"
    )
      v-card
        v-card-title Are You Sure?
        v-card-text Deleting a Project removes all associated Sites and
          b cannot be undone!
          div.d-flex.mt-3
            v-btn(
              color="success"
              @click="areYouSure = false"
            ) No! Don't Delete!
            v-btn.ml-auto(
              color="warning"
              @click="deleteProject"
            ) I'm Sure.
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";

export default {
    name: "Projects",
    async created() {
        await this.$store.dispatch("getCurrentURL");
    },
    data() {
        return {
            selected: [],
            areYouSure: false,
            editModal: false,
            showModal: false,
            newProject: {
                name: undefined,
                code: undefined,
                description: undefined
            },
            editProject: {
                name: null,
                code: null,
                description: null
            },
            headers: [
                { text: "Project Number", value: "attributes.code" },
                { text: "Name", value: "attributes.name" },
                { text: "Description", value: "attributes.description" }
            ]
        };
    },
    computed: {
        ...mapGetters("project", {
            projects: "getAllProject"
        })
    },
    methods: {
        ...mapActions("project", [
            "deleteAProject",
            "fetchAllProject",
            "putAProject",
            "createAProject"
        ]),
        ...mapMutations(["setNotification"]),
        rowClick(row) {
            this.$router.push({ path: `project/${row.id}/site` });
        },
        editSelectedProject() {
            if (this.selected.length > 0) {
                this.editProject.name = this.selected[0].attributes.name;
                this.editProject.code = this.selected[0].attributes.code;
                this.editProject.description = this.selected[0].attributes.description;
                this.editModal = true;
            } else {
                this.setNotification("No Project Selected");
            }
        },
        saveEditProject() {
            this.putAProject({
                url: this.selected[0].links.self,
                payload: this.editProject
            }).then(response => {
                this.fetchAllProject({
                    url: this.$store.state.user.data.relationships.projects
                        .links.related
                });
                this.setNotification("Project Saved");
                this.editModal = false;
            });
        },
        deleteProject() {
            if (this.selected.length > 0) {
                this.deleteAProject(this.selected[0].links.self).then(
                    response => {
                        this.fetchAllProject({
                            url: this.$store.state.user.data.relationships
                                .projects.links.related
                        });
                        this.setNotification("Project Deleted");
                    }
                );
            } else {
                this.setNotification("No Project Selected");
            }
            this.areYouSure = false;
        },
        saveNewProject() {
            this.createAProject({
                url: this.projects.links.self,
                payload: this.newProject
            }).then(response => {
                this.$store.dispatch("getCurrentURL");
                this.setNotification("Project Saved");
            });
            this.showModal = false;
        }
    }
};
</script>
